/*
 * Copyright 1994, 1995 Vectaport Inc.
 *
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the names of the copyright holders not be used in
 * advertising or publicity pertaining to distribution of the software
 * without specific, written prior permission.  The copyright holders make
 * no representations about the suitability of this software for any purpose.
 * It is provided "as is" without express or implied warranty.
 *
 * THE COPYRIGHT HOLDERS DISCLAIM ALL WARRANTIES WITH REGARD TO THIS
 * SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS.
 * IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY SPECIAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING
 * FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
 * NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
 * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 * 
 */

#ifndef mapviewstate_h
#define mapviewstate_h

extern "C" {
#include "projects.h"
}

#include <Unidraw/enter-scope.h>
#include <MapUnidraw/maptheme.h>

class FullGraphic;
class Graphic;
class MapFeature;
class Transformer;

class MapViewState {
public:
    MapViewState();
    MapViewState(PJ*);
    virtual ~MapViewState();

    virtual Graphic* themegs(MapFeature*) const;
    virtual Transformer* deftrans() const;
    boolean normtrans(){ return _normtrans; }
    void normtrans(boolean flag) { _normtrans= flag; }
    PJ* defproj() const;
    boolean projchanged();
    PJ* implicitproj() const;
    
    void settrans(Transformer*);
    void defproj(PJ*);
    void projchanged(boolean);
    void implicitproj(PJ*);

    long count() const;
    MapTheme* item(long index) const;

    void prepend(MapTheme*);
    void append(MapTheme*);
    void insert(long index, MapTheme*);
    void remove(long index);
    void remove_all();
protected:
    Transformer* _trans;
    boolean _normtrans;
    PJ* _proj;
    PJ* _implicit_proj;
    MapThemeList* _themes;
    FullGraphic* _default_gs;
};

#endif
